::capsDelegate <- {

    setTeam = function(newTeamNum) {
        handleTeamChange(newTeamNum, teamNum)
        teamNum = newTeamNum
        return this
    }
    
    handleTeamChange = @(newTeamNum, oldTeamNum) null // Instance Hook
}

::cap <- {}
::setupCap <- function(group) {

    local cap = {
        teamNum = null
        group = group
    }.setdelegate(::capsDelegate)
    ::cap[group] <- cap

    local capturePoint = ::first("cap_"+group)
    ::getScope(capturePoint).handler <- cap

    ::createTimer(0, function() {
        EntityOutputs.AddOutput(capturePoint, "OnCapTeam1", "!self", "RunScriptCode", "handler.setTeam(2)", 0, -1)
        EntityOutputs.AddOutput(capturePoint, "OnCapTeam2", "!self", "RunScriptCode", "handler.setTeam(3)", 0, -1)
        EntityOutputs.AddOutput(capturePoint, "OnCapReset", "!self", "RunScriptCode", "handler.setTeam(0)", 0, -1)
    })

    return cap.setTeam(capturePoint.GetTeam())
}